package wacc

import wacc.ast.Position
import wacc.types._

enum Error {
  case DuplicateDeclaration(ident: ast.Ident)
  case UndefinedIdentifier(ident: ast.Ident, identType: renamer.IdentType)
  case FunctionParamsMismatch(expected: Int, got: Int) // TODO not fine

  case SemanticError(pos: Position, msg: String)
  case TypeMismatch(pos: Position, expected: SemType, got: SemType, msg: String)
  case InternalError(pos: Position, msg: String)
}
